/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.data;

import android.content.Context;
import android.database.Cursor;
import android.provider.ContactsContract.CommonDataKinds.Phone;
import android.provider.ContactsContract.Data;
import android.telephony.PhoneNumberUtils;
import android.util.Log;

import java.util.HashMap;

/**
 * 用于处理联系人信息的工具类，提供根据电话号码查询联系人姓名的功能。
 */
public class Contact {
    // 用于缓存电话号码与联系人姓名的映射，减少频繁的数据库查询
    private static HashMap<String, String> sContactCache;
    
    // 用于日志打印
    private static final String TAG = "Contact";

    // 用于查询联系人信息的 SQL 选择条件 (selection)
    private static final String CALLER_ID_SELECTION = "PHONE_NUMBERS_EQUAL(" + Phone.NUMBER
    + ",?) AND " + Data.MIMETYPE + "='" + Phone.CONTENT_ITEM_TYPE + "'"
    + " AND " + Data.RAW_CONTACT_ID + " IN "
            + "(SELECT raw_contact_id "
            + " FROM phone_lookup"
            + " WHERE min_match = '+')";

    /**
     * 根据电话号码查询联系人姓名，如果之前已经查询过该号码，会直接从缓存中获取
     *
     * @param context 上下文对象，用于访问联系人数据
     * @param phoneNumber 需要查询的电话号码
     * @return 对应电话号码的联系人姓名，如果没有找到，则返回 null
     */
    public static String getContact(Context context, String phoneNumber) {
        // 如果缓存为空，初始化缓存 HashMap
        if(sContactCache == null) {
            sContactCache = new HashMap<String, String>();
        }

        // 如果缓存中已经有该电话号码的联系人信息，则直接返回缓存中的结果
        if(sContactCache.containsKey(phoneNumber)) {
            return sContactCache.get(phoneNumber);
        }

        // 替换 selection 中的占位符 "+" 为通过 PhoneNumberUtils 转换的号码格式
        String selection = CALLER_ID_SELECTION.replace("+",
                PhoneNumberUtils.toCallerIDMinMatch(phoneNumber));
        
        // 使用内容解析器查询联系人数据
        Cursor cursor = context.getContentResolver().query(
                Data.CONTENT_URI,  // 查询的 URI
                new String[] { Phone.DISPLAY_NAME },  // 查询的列，获取联系人的显示名称
                selection,  // 查询条件
                new String[] { phoneNumber },  // 查询参数，传入电话号码
                null);  // 不需要排序

        // 如果查询成功且结果不为空
        if (cursor != null && cursor.moveToFirst()) {
            try {
                // 获取联系人名称
                String name = cursor.getString(0);
                // 将联系人姓名存入缓存中，避免下次查询时再次访问数据库
                sContactCache.put(phoneNumber, name);
                return name;
            } catch (IndexOutOfBoundsException e) {
                // 如果在游标操作中出现异常，记录日志并返回 null
                Log.e(TAG, " Cursor get string error " + e.toString());
                return null;
            } finally {
                // 无论查询是否成功，都需要关闭游标
                cursor.close();
            }
        } else {
            // 如果没有找到匹配的联系人，记录日志并返回 null
            Log.d(TAG, "No contact matched with number:" + phoneNumber);
            return null;
        }
    }
}